debug = false;
var debug_filter = null;
function log() {
    if(!debug) return;
    var args = Array.prototype.slice.call(arguments);
    var text = args.join(" ");
    if(debug) {
        if(debug_filter) {
            if(text.match(debug_filter)) console.log(text);
        } else {
            console.log(text);
        }
    }
}
arguments = [];

function heap_store(address, value) {
    HEAP[address] = value;
    //SAFE_HEAP_STORE(address, value, 'i32', true);
}

function init_offsets(offsets, names) {
    output = {};
    for(var i = 0; i < offsets.length; i++) {
        output[names[i]] = offsets[i];
    }
    return output;
}
// 0,4,12,16,20,24,28,32,40,120,200,204
var Ez_event;
var defines = {
    KeyPress:           2,
    KeyRelease:         3,
    ButtonPress:        4,
    ButtonRelease:      5,
    MotionNotify:       6,
    Expose:            12,
    ConfigureNotify:   22,
    ClientMessage:     33,
    LASTEvent:         35,
    WindowClose:       37,
    TimerNotify:       38,
    EzLastEvent:       39,
    /* Timer */
    EZ_TIMER1:        208,
};
Ez_Align = { 
    183200: 'EZ_AA',
    183201: 'EZ_TL', 183202: 'EZ_TC', 183203: 'EZ_TR',
    183204: 'EZ_ML', 183205: 'EZ_MC', 183206: 'EZ_MR',
    183207: 'EZ_BL', 183208: 'EZ_BC', 183209: 'EZ_BR',
    183210: 'EZ_BB',
    183211: 'EZ_TLF', 183212: 'EZ_TCF', 183213: 'EZ_TRF',
    183214: 'EZ_MLF', 183215: 'EZ_MCF', 183216: 'EZ_MRF',
    183217: 'EZ_BLF', 183218: 'EZ_BCF', 183219: 'EZ_BRF',
    183220: 'EZ_CC',
};

// print function which the runtime will call
var contexts = [];
var events = [];
function print(text) {
    log(text);
    //console.log(text);
}
function _perror(error) {
    log(Pointer_stringify(error));
}
function _ez_random(max) {
    var x = Math.floor(Math.random() * max);
    log("ez_random(",max,"->",x);
    return x;
} 

var _fonts = ["11pt misc_fixed", "13pt misc_fixed", "16pt misc_fixed", "20pt misc_fixed"];

function _ez_set_nfont(num) {
    for(var i = 0; i < contexts.length; i++) {
        var context = contexts[i];
        context.font = _fonts[num] + ",Courier";
    }
    log("ez_set_font(", _fonts[num] , ")");
}
var stop_timeout = [];
function _ez_start_timer(win, delay) {
    var _evt = events[win];
    log("ez_start_timer(", delay, ")");
    if(delay >= 0) {
        stop_timeout[win] = false;
        setTimeout(function() {
            if(stop_timeout[win] == true) return;
            heap_store(_evt, defines.TimerNotify);
            heap_store(_evt + 4, win);
            if(event_functions[win] != 0) event_functions[win](_evt);
        }, delay);
    } else {
        stop_timeout[win] = true;
    }
}
function _ez_send_expose(win) {
    var context = contexts[win];
    var _evt = events[win];
    log("_ez_send_expose");
    context.clearRect(0, 0, contexts[win].canvas.width, contexts[win].canvas.height);
    heap_store(_evt + Ez_event.type, defines.Expose); // set type
    heap_store(_evt + Ez_event.win, win);
    if(event_functions[win] != 0) event_functions[win](_evt);
}
function _ez_set_color(color) {
    var r = ((color & 0xff0000) / 65536) | 0;
    var g = ((color & 0x00ff00) / 256) | 0;
    var b = (color & 0x0000ff) | 0;
    rgb = "rgb(" + r + "," + g + "," + b + ")";
    log("_ez_set_color(", color, "->", rgb, ")");
    for(var i = 0; i < contexts.length; i++) {
        var context = contexts[i];
        context.strokeStyle = rgb;
        context.fillStyle = rgb;
    }
}
function _ez_draw_text(win, alignment, x, y, text, varargs) {
    var args = Array.prototype.slice.call(arguments).slice(5);  
    log("_ez_draw_text(", win, alignment, x, y, text, args);
    var context = contexts[win];
    // TODO: correct font, line breaks
    //text = Pointer_stringify(text);
    var output = _malloc(16384);
    _vsprintf(output, text, varargs);
    text = Pointer_stringify(output);
    var lines = text.split("\n");
    alignment = Ez_Align[alignment];
    var height = parseInt(context.font) + 2;
    var total_height = height * lines.length;
    /*if(alignment.match('.*_T')) { context.textBaseline = "top"; }
    else if(alignment.match('.*_M')) { context.textBaseline = "middle"; }
    else if(alignment.match('.*_B')) { context.textBaseline = "bottom"; y -= height * (lines.length - 1); }*/
    context.textBaseline = "top";
    if(alignment.match('.*_M')) { y -= total_height / 2; }
    else if(alignment.match('.*_B')) { y -= total_height; }
    if(alignment.match('CF?$')) { context.textAlign = "center"; }
    else if(alignment.match('RF?$')) { context.textAlign = "right"; }
    else if(alignment.match('LF?$')) { context.textAlign = "left"; }
    for(var i = 0; i < lines.length; i++) {
        context.fillText(lines[i], x, y);
        y += height;
    }
    log("_ez_draw_text(", win, alignment, x, y, text, args);
    _free(output);
}
function _ez_fill_rectangle(win, x, y, w, z) {
    var context = contexts[win];
    w += 1;
    z += 1;
    var x1 = x > w ? x : w;
    var y1 = y > z ? y : z;
    var x2 = x > w ? w : x;
    var y2 = y > z ? z : y;
    context.fillRect(x1, y1, x2 - x1, y2 - y1);
    log("_ez_fill_rectangle(", x, y, w, z, ")");
}
function _ez_draw_rectangle(win, x, y, w, z) {
    var context = contexts[win];
    var x1 = x > w ? x : w;
    var y1 = y > z ? y : z;
    var x2 = x > w ? w : x;
    var y2 = y > z ? z : y;
    context.strokeRect(x1, y1, x2 - x1, y2 - y1);
    log("_ez_draw_rectangle(", x, y, w, z, ")");
}
function _ez_draw_line(win, x, y, w, z) { 
    log("ez_draw_line(", x, y, w, z,")");
    var context = contexts[win];
    context.beginPath();
    context.moveTo(x, y);
    context.lineTo(w, z);
    context.stroke();
}
function _ez_draw_point(win, x, y) {
    log("ez_draw_point(", x, y, ")");
    var context = contexts[win];
    context.fillRect(x, y, 1, 1);
}
function _ez_draw_triangle(win, x1, y1, x2, y2, x3, y3) {
    log("ez_draw_triangle(", x1, y1, x2, y2, x3, y3, ")");
    var context = contexts[win];
    context.beginPath();
    context.moveTo(x1, y1);
    context.lineTo(x2, y2);
    context.lineTo(x3, y3);
    context.closePath();
    context.stroke();
}
function _ez_fill_triangle(win, x1, y1, x2, y2, x3, y3) {
    log("ez_fill_triangle(", x1, y1, x2, y2, x3, y3, ")");
    var context = contexts[win];
    context.beginPath();
    context.moveTo(x1, y1);
    context.lineTo(x2, y2);
    context.lineTo(x3, y3);
    context.closePath();
    context.fill();
}
function _ez_draw_circle(win, x1, y1, x2, y2) {
    log("ez_draw_circle(", x1, y1, x2, y2, ")");
    var context = contexts[win];
    var w = Math.abs(x1 - x2);
    var h = Math.abs(y1 - y2);
    var kappa = .5522848;
    var ox = (w / 2) * kappa, // control point offset horizontal
       oy = (h / 2) * kappa, // control point offset vertical
       xe = x1 + w,           // x-end
       ye = y1 + h,           // y-end
       xm = x1 + w / 2,       // x-middle
       ym = y1 + h / 2;       // y-middle

    context.beginPath();
    context.moveTo(x1, ym);
    context.bezierCurveTo(x1, ym - oy, xm - ox, y1, xm, y1);
    context.bezierCurveTo(xm + ox, y1, xe, ym - oy, xe, ym);
    context.bezierCurveTo(xe, ym + oy, xm + ox, ye, xm, ye);
    context.bezierCurveTo(xm - ox, ye, x1, ym + oy, x1, ym);
    context.closePath();
    context.stroke();
}
function _ez_fill_circle(win, x1, y1, x2, y2) {
    log("ez_fill_circle(", x1, y1, x2, y2, ")");
    x2 += 1;
    y2 += 1;
    var context = contexts[win];
    var w = Math.abs(x1 - x2);
    var h = Math.abs(y1 - y2);
    var kappa = .5522848;
    var ox = (w / 2) * kappa, // control point offset horizontal
       oy = (h / 2) * kappa, // control point offset vertical
       xe = x1 + w,           // x-end
       ye = y1 + h,           // y-end
       xm = x1 + w / 2,       // x-middle
       ym = y1 + h / 2;       // y-middle

    context.beginPath();
    context.moveTo(x1, ym);
    context.bezierCurveTo(x1, ym - oy, xm - ox, y1, xm, y1);
    context.bezierCurveTo(xm + ox, y1, xe, ym - oy, xe, ym);
    context.bezierCurveTo(xe, ym + oy, xm + ox, ye, xm, ye);
    context.bezierCurveTo(xm - ox, ye, x1, ym + oy, x1, ym);
    context.closePath();
    context.fill();
}
function _ez_get_RGB(r, g, b) {
    log("ez_get_RGB(", r,g,b, ")");
    while(r<0) r+= 256;
    while(g<0) g+= 256;
    while(b<0) b+= 256;
    return (r&0xff) * 65536 + (g&0xff) * 256 + (b&0xff);
}
function _ez_get_grey(shade) {
    log("ez_get_grey(", shade, ")");
    return _ez_get_RGB(shade, shade, shade);
}
function _ez_set_thick(thickness) {
    log("ez_set_thick(", thickness, ")");
    for(var i  = 0; i < contexts.length; i++) {
        contexts[i].lineWidth = thickness;
    }
}
function _ez_font_load(num, name) {
    log("ez_font_load(", num, name, ")");
    _fonts[num] = name;
}
function _ez_quit() {
    log("ez_quit"); 
    history.back(-1);
}
_auto_quit = 1;
function _ez_auto_quit(val) {
    _auto_quit = val;
    log("ez_auto_quit"); 
}
function _ez_init() { 
    log("ez_init");
    Ez_event = init_offsets($struct_Ez_event___FLATTENER, ['type', 'win', 'mx', 'my', 'mb', 'width', 'height', 'key_sym', 'key_name', 'key_string', 'key_count', 'xev']);
    _ez_black = Runtime.staticAlloc(4); // init a few colors
    _ez_red = Runtime.staticAlloc(4);
    _ez_green = Runtime.staticAlloc(4);
    _ez_yellow = Runtime.staticAlloc(4);
    _ez_grey = Runtime.staticAlloc(4);
    _ez_blue = Runtime.staticAlloc(4);
    _ez_magenta = Runtime.staticAlloc(4);
    _ez_white = Runtime.staticAlloc(4);
    _ez_cyan = Runtime.staticAlloc(4);
    heap_store(_ez_black, 0x000000);
    heap_store(_ez_red, 0xff0000);
    heap_store(_ez_green, 0x00ff00);
    heap_store(_ez_yellow, 0xffff00);
    heap_store(_ez_grey, 0xdddddd);
    heap_store(_ez_blue, 0x0000ff);
    heap_store(_ez_magenta, 0xff00ff);
    heap_store(_ez_white, 0xffffff);
    return 0;
}
var window_data = [];
function _ez_set_data(win, data) {
    window_data[win] = data;
}
function _ez_get_data(win) {
    return window_data[win];
}
function _ez_window_get_size(win, width, height) {
    log("ez_window_getsize(",win, width, height, ")");
    heap_store(width, contexts[win].canvas.width);
    heap_store(height, contexts[win].canvas.height);
}
function _ez_window_set_size(win, width, height) {
    log("ez_window_setsize(",win, width, height, ")");
    contexts[win].canvas.width = width;
    contexts[win].canvas.height = height;
}
function _ez_window_show(win, visibility) { 
    log("ez_window_show(",win, ")");
    if(visibility == 0) {
        $(contexts[win].canvas).parent().hide();
        $("#desktop").find(".bar").css("background", "white").css("color", "black");
    } else {
        $(contexts[win].canvas).parent().show();
        $("#desktop").find(".bar").css("background", "white").css("color", "black");
        $(contexts[win].canvas).parent().focus().find(".bar").css("background","blue").css("color","white");
    }
}
var event_functions = [];
var key_mapping = {
    8:0xff08, // backspace
    9:0xff09, // tab
    13:0xff0d, // enter
    16:0xffe1, // shift
    17:0xffe3, // control
    18:0xffe9, // alt
    19:0xff13, // pause
    20:0xffe5, // caps lock
    27:0xff1b, // esc
    //33:, // page up
    //34:, // page down
    35:0xff57, // end
    36:0xff50, // home
    38:0xff52, // up
    40:0xff54, // down
    39:0xff53, // right 
    37:0xff51, // left
    45:0xff63, // insert
    46:0xffff, // delete
    //91:, // windows
    112:0xffbe, // F1
    113:0xffbf, // F2
    114:0xffc0, // F3
    115:0xffc1, // F4
    116:0xffc2, // F5
    117:0xffc3, // F6
    118:0xffc4, // F7
    119:0xffc5, // F8
    120:0xffc6, // F9
    121:0xffc7, // F10
    122:0xffc8, // F11
    123:0xffc9, // F12
};
function _ez_window_destroy(win) {
    // TODO: notify of WindowClose
    $("#desktop").find(".bar").css("background", "white").css("color", "black");
    $(contexts[win].canvas).parent().remove();
    if(event_functions[win] != 0) {
        var _evt = events[win];
        heap_store(_evt + Ez_event.type, defines.WindowClose); // set type
        heap_store(_evt + Ez_event.win, win);
        event_functions[win](_evt);
    }
}
function _ez_window_create(width, height, title, event_function) {
    log("ez_window_create(", width, height, Pointer_stringify(title), event_function, ")");
    stop_timeout.push(false);
    if(title != null) { title = Pointer_stringify(title); }
    else { title = "Window " + (contexts.length + 1); }
    var frame = $('<div class="frame" style="display:inline-block;margin:5px;">'
        +    '<div class="bar" style="background:white;color:black;padding-left:5px;padding-right:5px;border:1px solid black;border-bottom:0px;">'
        +        '<span class="title">' + title + '</title><span class="close" style="float:right;">X</span>'
        +    '</div>'
        +    '<canvas></canvas>'
        + '</div>');
    $("#desktop").append(frame);
    var canvas = frame.find("canvas").get(0);
    canvas.width = width;
    canvas.height = height;
    canvas.style.border = "1px solid black";
    window_data.push(0);
    var context = canvas.getContext("2d");
    context.font = _fonts[0];
    context.translate(0.5, 0.5);
    contexts.push(context);
    var win = contexts.length - 1;
    frame.get(0).setAttribute('tabindex', win);
    frame.focus(); // give focus to new window
    $("#desktop").find(".bar").css("background", "white").css("color", "black");
    frame.find(".bar").css("background","blue").css("color","white");
    var _evt = Runtime.staticAlloc($struct_Ez_event___SIZE); // one event for everybody
    events.push(_evt);
    var _event_function = FUNCTION_TABLE[event_function];
    event_functions.push(_event_function);
    if(_event_function == 0) return; // no events
    frame.find('.close').click(function(event) {
        log("close");
        if(_auto_quit) {
            _ez_quit();
        } else {
            heap_store(_evt + Ez_event.type, defines.WindowClose); // set type
            heap_store(_evt + Ez_event.win, win);
            _event_function(_evt);
        }
    });
    frame.keydown(function(event) {
        // TODO: fix non-letter keys
        keyCode = event.keyCode;
        if(key_mapping[keyCode] != null) {
            keyCode = key_mapping[keyCode];
        }
        if(keyCode >= 65 && keyCode <= 90 && event.shiftKey == false) {
            keyCode += 32;
        }
        log("keydown:",keyCode);
        heap_store(_evt + Ez_event.type, defines.KeyPress); // set type
        heap_store(_evt + Ez_event.win, win);
        heap_store(_evt + Ez_event.key_sym, keyCode);
        if(keyCode >=32 && keyCode < 256) {
            heap_store(_evt + Ez_event.key_string, keyCode);
            heap_store(_evt + Ez_event.key_count, 1);
        } else {
            heap_store(_evt + Ez_event.key_count, 0);
        }
        _event_function(_evt);
        return true;
    });
    frame.keyup(function(event) {
        // TODO: fix non-letter keys
        keyCode = event.keyCode;
        if(key_mapping[keyCode] != null) {
            keyCode = key_mapping[keyCode];
        }
        if(keyCode >= 65 && keyCode <= 90 && event.shiftKey == false) {
            keyCode += 32;
        }
        log("keyup:", keyCode);
        heap_store(_evt + Ez_event.type, defines.KeyRelease); // set type
        heap_store(_evt + Ez_event.win, win);
        heap_store(_evt + Ez_event.key_sym, keyCode);
        if(keyCode >=32 && keyCode < 256) {
            heap_store(_evt + Ez_event.key_string, keyCode);
            heap_store(_evt + Ez_event.key_count, 1);
        } else {
            heap_store(_evt + Ez_event.key_count, 0);
        }
        _event_function(_evt);
        return true;
    });
    $(canvas).mousedown(function(event) {
        log("mousedown");
        heap_store(_evt + Ez_event.type, defines.ButtonPress); // set type
        heap_store(_evt + Ez_event.win, win);
        heap_store(_evt + Ez_event.mb, 1);
        heap_store(_evt + Ez_event.mx, event.pageX - this.offsetLeft);
        heap_store(_evt + Ez_event.my, event.pageY - this.offsetTop);
        _event_function(_evt);
        return false;
    });
    $(canvas).mouseup(function(event) {
        log("mouseup");
        heap_store(_evt + Ez_event.type, defines.ButtonRelease); // set type
        heap_store(_evt + Ez_event.win, win);
        heap_store(_evt + Ez_event.mb, 0);
        heap_store(_evt + Ez_event.mx, event.pageX - this.offsetLeft);
        heap_store(_evt + Ez_event.my, event.pageY - this.offsetTop);
        _event_function(_evt);
        return false;
    });
    $(canvas).mousemove(function(event) {
        $(this).parent().focus();
        $("#desktop").find(".bar").css("background", "white").css("color", "black");
        $(this).parent().find(".bar").css("background","blue").css("color","white");
        log("mousemove");
        heap_store(_evt + Ez_event.type, defines.MotionNotify); // set type
        heap_store(_evt + Ez_event.win, win);
        heap_store(_evt + Ez_event.mx, event.pageX - this.offsetLeft);
        heap_store(_evt + Ez_event.my, event.pageY - this.offsetTop);
        _event_function(_evt);
        return false;
    });
    _ez_send_expose(win);
    return win;
}
function _ez_window_dbuf(win, val) {
    _ez_send_expose(win); // seems to imply expose()
    log("ez_window_dbuf()");
}
function _ez_main_loop() {
    for(var win = 0; win < contexts.length; win++)
        _ez_send_expose(win); // seems to imply expose()
    log("ez_main_loop()");
}

